<?php
namespace OrganizationsManagement\Factory;

use Teknisa\Model\Teknisa\Entities\OmParamOrg as ParamOrgEntity;
use Teknisa\Model\Teknisa\Entities\OmParamOrgDefault as ParamOrgDefault;
use Teknisa\Model\Util\NovoCodigo as NovoCodigo;

class OrganizationParameters {

    public function save(ParamOrgEntity $organizationParameters = null, $orgId, $currentOrgId, $codOperador, $dateNow,
                         $useRestriction, $allowProductCall, $idColetor, $dsStringConexao, $idUtWallet, $dsUsuarioBanco, $dsSenhaBanco, $idTpBanco)
    {
        if ($organizationParameters === null) {
            $organizationParameters = new ParamOrgEntity();
            $organizationParameters->setCdoperinclusao($codOperador);
            $organizationParameters->setNrorginclusao($currentOrgId);
            $organizationParameters->setDtinclusao($dateNow);
            $organizationParameters->setNrorg($orgId);
        }
        
        $organizationParameters->setCdoperultatu($codOperador);
        $organizationParameters->setNrorgultatu($currentOrgId);
        $organizationParameters->setDtultatu($dateNow);
        
        $organizationParameters->setIdutiprestriction($useRestriction);
        $organizationParameters->setIdallowproductcall($allowProductCall);
        
        $organizationParameters->setIdcoletor($idColetor);
        $organizationParameters->setDsstringconexao($dsStringConexao);
        $organizationParameters->setIdutwallet($idUtWallet);
        $organizationParameters->setDsusuariobanco($dsUsuarioBanco);
        $organizationParameters->setDssenhabanco($dsSenhaBanco);
        $organizationParameters->setIdtpbanco($idTpBanco);
        
        return $organizationParameters;
    }

    public function saveDefaultParams(ParamOrgDefault $defaultParameters = null, $currentOrgId, $codOperador, $dateNow,
                         $idColetor, $dsStringConexao, $idUtWallet, $dsUsuarioBanco, $dsSenhaBanco, $idativo, $idabmorg, $idTpBanco)
    {
        if ($defaultParameters === null) {
            $defaultParameters = new ParamOrgDefault();
            $novoCodigo = NovoCodigo::geraCodigo($currentOrgId, "OM_PARAM_ORG_DEFAULT", 1, 10, false, false);
            $defaultParameters->setId($novoCodigo);
            $defaultParameters->setCdoperinclusao($codOperador);
            $defaultParameters->setNrorginclusao($currentOrgId);
            $defaultParameters->setDtinclusao($dateNow);
            $defaultParameters->setNrorg($currentOrgId);
        }
        
        $defaultParameters->setCdoperultatu($codOperador);
        $defaultParameters->setNrorgultatu($currentOrgId);
        $defaultParameters->setDtultatu($dateNow);
        
        $defaultParameters->setIdativo($idativo);
        $defaultParameters->setIdamborg($idabmorg);
        $defaultParameters->setIdcoletor($idColetor);
        $defaultParameters->setDsstringconexao($dsStringConexao);
        $defaultParameters->setIdutwallet($idUtWallet);
        $defaultParameters->setDsusuariobanco($dsUsuarioBanco);
        $defaultParameters->setDssenhabanco($dsSenhaBanco);
        $defaultParameters->setIdtpbanco($idTpBanco);
        
        return $defaultParameters;
    }
}
