<?php

namespace Zeedhi\Zmart\QueryBuilders\Mongo;


use Zeedhi\Framework\DataSource\FilterCriteria;

class Exception extends \Exception{

    public static function invalidSortDirection($sortDirection) {
        return new static ("Invalid Sort Direction {$sortDirection}. Accepted sort directions 1 or "
            .FilterCriteria::ORDER_ASC." to ascendant, -1 or ".FilterCriteria::ORDER_DESC." to descendent");
    }

    public static function invalidBetween($between) {
        return new static ("Invalid between value. It should be an array with first key as the lower value and second as the greater. Given value was "
            . serialize($between));
    }

    public static function invalidContentType($type) {
        return new static ("Invalid content type: {$type}. Types accepteds: \\Zeedhi\\Zmart\\Util\\MathExpression, String and Number");
    }

    public static function invalidOperator($operator) {
        $exceptionMessage = "Invalid operator {$operator}. Operators accepted: ";
        $operatorAccepted = implode(', ', array_keys(QueryBuilder::$OPERATORS_COMPARISON));
        $exceptionMessage .= $operatorAccepted;
        return new static ($exceptionMessage);
    }

    public static function invalidFunction($function) {
        $exceptionMessage = "Invalid function {$function}. Functions accepted: ";
        $allFunctions = array_merge(array_keys(QueryBuilder::$AGGREGATE_FUNCTIONS), array_keys(QueryBuilder::$AGGREGATE_SPECIAL_FUNCTIONS));
        $functionsAccepted = implode(', ',$allFunctions );
        $exceptionMessage .= $functionsAccepted;
        return new static ($exceptionMessage);
    }
} 