CREATE OR REPLACE PROCEDURE GERA_HISTCARDAMES
(
	P_CDFILIAL VARCHAR2,
	P_CDSERVFILI VARCHAR2,
	P_DTMESCARD DATE,
	P_CDTIPOCUSTO VARCHAR2,
	P_DTREFECUSTO DATE,
	P_NRORG NUMBER,
	P_CDOPERADOR VARCHAR2
)
AS
	V_QTDE NUMBER;
	V_NRVERCARDAMES NUMBER;
	V_NRVERCARDADIA NUMBER;
	V_NRVERCARDACLI NUMBER;
	V_NRVERCONSSERV NUMBER;
	V_NRVERCNFCAMES NUMBER;
	V_NRVERCOMPCARD NUMBER;
	V_NRVERCUSTOPRODUTOCAR NUMBER;
	V_NRVERRECEPRATOCAR NUMBER;
	V_IDTIPORECE VARCHAR2(1);
	V_SGUNIDADE VARCHAR2(10);
	V_VRCUSTO FLOAT;
	CUR_CONSSERV UTIL_CONSPLAN_PLA.CONSSERV_CURTYPE;
   REC_CONSSERV UTIL_CONSPLAN_PLA.CONSSERV_RECTYPE;
   CUR_PRODPRAT UTIL_CONSPLAN_PLA.PRODPRAT_CURTYPE;
   REC_PRODPRAT UTIL_CONSPLAN_PLA.PRODPRAT_RECTYPE;
BEGIN
	SELECT COUNT(1)
	  INTO V_QTDE
	  FROM CARDADIA
	 WHERE CDFILIAL = P_CDFILIAL
	   AND CDSERVFILI = P_CDSERVFILI
	   AND DTMESCARD = P_DTMESCARD;
	IF V_QTDE = 0 THEN		
		/*Se no existe cardpio no gera congelamento*/		
		RETURN;
	END IF;

	SELECT COUNT(1)
	  INTO V_QTDE
	  FROM CARDAMES
	 WHERE CDFILIAL = P_CDFILIAL
	   AND CDSERVFILI = P_CDSERVFILI
	   AND DTMESCARDAPIO = P_DTMESCARD;

	IF V_QTDE = 0 THEN
		INSERT INTO CARDAMES
		(CDFILIAL, CDSERVFILI, DTMESCARDAPIO, 
		 DTREFECUSTMES)
      VALUES 
      (P_CDFILIAL, P_CDSERVFILI, P_DTMESCARD, 
       P_DTREFECUSTO);
	END IF;

	-- Mantm apenas o ltimo congelamento para cada CARDAMES
	SELECT MAX(NRVERCARDAMES)
	  INTO V_NRVERCARDAMES
	  FROM VERCARDAMES
	 WHERE CDFILIAL = P_CDFILIAL
	   AND CDSERVFILI = P_CDSERVFILI
	   AND DTMESCARDAPIO = P_DTMESCARD;

	IF V_NRVERCARDAMES IS NOT NULL THEN
		/*Filhas so apagadas por cascata*/
		DELETE FROM VERCARDAMES
		WHERE NRVERCARDAMES = V_NRVERCARDAMES;
	END IF;

	V_NRVERCARDAMES := TO_NUMBER(RETORNA_NOVO_CODIGO('VERCARDAMES', 1));
	
	INSERT INTO VERCARDAMES
   (NRVERCARDAMES, CDFILIAL, CDSERVFILI, 
    DTMESCARDAPIO, CDTIPOCUSTO, DTREFECUSTMES, 
    NRORG, NRORGINCLUSAO, NRORGULTATU, 
    CDOPERINCLUSAO, CDOPERULTATU, 
    DTINCLUSAO, DTULTATU)
	VALUES
	(V_NRVERCARDAMES, P_CDFILIAL, P_CDSERVFILI,
	 P_DTMESCARD, P_CDTIPOCUSTO, P_DTREFECUSTO,
	 P_NRORG, P_NRORG, P_NRORG,
	 P_CDOPERADOR, P_CDOPERADOR,
	 SYSDATE, SYSDATE);

	FOR C_CNF IN
	(
		SELECT CDTIPOPRAT, 
             NRORDCNFMES, IDOPCCNFMES, IDIMPCNFMES, 
             NRPAGCNFMES, DSCOMPLTPMES, NRSEQCNFMES,
             IDTPPRATSEGM, IDTPPRATTERM, IDTPPRATQUAM, 
             IDTPPRATQUIM, IDTPPRATSEXM, IDTPPRATSABM, 
             IDTPPRATDOMM, IDTPPRATFERM
		  FROM CNFCAMES
		 WHERE CDFILIAL = P_CDFILIAL
		   AND CDSERVFILI = P_CDSERVFILI
		   AND DTREFECNFMES = P_DTMESCARD
	) LOOP
		V_NRVERCNFCAMES := TO_NUMBER(RETORNA_NOVO_CODIGO('VERCNFCAMES', 1));
		INSERT INTO VERCNFCAMES 
      (NRVERCNFCAMES, NRVERCARDAMES, CDTIPOPRAT, 
       NRORDCNFMES, IDOPCCNFMES, IDIMPCNFMES, 
       NRPAGCNFMES, DSCOMPLTPMES, NRSEQCNFMES,
       IDTPPRATSEGM, IDTPPRATTERM, IDTPPRATQUAM, 
       IDTPPRATQUIM, IDTPPRATSEXM, IDTPPRATSABM, 
       IDTPPRATDOMM, IDTPPRATFERM, 
	    NRORG, NRORGINCLUSAO, NRORGULTATU,
		 CDOPERINCLUSAO, CDOPERULTATU,
		 DTINCLUSAO, DTULTATU)
      VALUES
      (V_NRVERCNFCAMES, V_NRVERCARDAMES, C_CNF.CDTIPOPRAT, 
       C_CNF.NRORDCNFMES, C_CNF.IDOPCCNFMES, C_CNF.IDIMPCNFMES, 
       C_CNF.NRPAGCNFMES, C_CNF.DSCOMPLTPMES, C_CNF.NRSEQCNFMES,
       C_CNF.IDTPPRATSEGM, C_CNF.IDTPPRATTERM, C_CNF.IDTPPRATQUAM, 
       C_CNF.IDTPPRATQUIM, C_CNF.IDTPPRATSEXM, C_CNF.IDTPPRATSABM, 
       C_CNF.IDTPPRATDOMM, C_CNF.IDTPPRATFERM, 
	    P_NRORG, P_NRORG, P_NRORG,
	    P_CDOPERADOR, P_CDOPERADOR,
	    SYSDATE, SYSDATE);
	END LOOP;

	FOR C_CARDADIA IN
	(
		SELECT CDFILIAL, CDSERVFILI, NRCARDAPIO, DTCARDAPIO, CDDIETPAD, 
		       QTCOMESTICAR, QTCLIESTICAR, QTFUNESTICAR, QTDOAESTICAR,
		       QTESTITURNO1, QTESTITURNO2, QTESTITURNO3, QTESTITURNO4,
             QTCOMEFETCAR, QTCLIEFETCAR, QTFUNEFETCAR, QTDOAEFETCAR
		  FROM CARDADIA
		 WHERE CDFILIAL = P_CDFILIAL
		   AND CDSERVFILI = P_CDSERVFILI
		   AND DTMESCARD = P_DTMESCARD
	) LOOP
		V_NRVERCARDADIA := TO_NUMBER(RETORNA_NOVO_CODIGO('VERCARDADIA', 1));

		INSERT INTO VERCARDADIA
      (NRVERCARDADIA, NRVERCARDAMES, DTCARDAPIO, CDFILIAL, NRCARDAPIO,
       CDDIETPAD, QTCOMESTICAR, QTCLIESTICAR, QTFUNESTICAR, QTDOAESTICAR,
       QTESTITURNO1, QTESTITURNO2, QTESTITURNO3, QTESTITURNO4,
       QTCOMEFETCAR, QTCLIEFETCAR, QTFUNEFETCAR, QTDOAEFETCAR,       
 	    NRORG, NRORGINCLUSAO, NRORGULTATU,
		 CDOPERINCLUSAO, CDOPERULTATU,
		 DTINCLUSAO, DTULTATU)
     	VALUES
     	(V_NRVERCARDADIA, V_NRVERCARDAMES, C_CARDADIA.DTCARDAPIO, C_CARDADIA.CDFILIAL, C_CARDADIA.NRCARDAPIO,
     	 C_CARDADIA.CDDIETPAD, C_CARDADIA.QTCOMESTICAR, C_CARDADIA.QTCLIESTICAR, C_CARDADIA.QTFUNESTICAR, C_CARDADIA.QTDOAESTICAR,
       C_CARDADIA.QTESTITURNO1, C_CARDADIA.QTESTITURNO2, C_CARDADIA.QTESTITURNO3, C_CARDADIA.QTESTITURNO4,  
       C_CARDADIA.QTCOMEFETCAR, C_CARDADIA.QTCLIEFETCAR, C_CARDADIA.QTFUNEFETCAR, C_CARDADIA.QTDOAEFETCAR,
       P_NRORG, P_NRORG, P_NRORG,
	    P_CDOPERADOR, P_CDOPERADOR,
	    SYSDATE, SYSDATE);
     	
		FOR C_CARDACLI IN
		(
			SELECT CDCLIENTE, CDFILIAL, CDDESTFILI, QTCOMESTICLI
			  FROM CARDACLI
			 WHERE CDFILIAL = C_CARDADIA.CDFILIAL			   
			   AND NRCARDAPIO = C_CARDADIA.NRCARDAPIO
		) LOOP
			V_NRVERCARDACLI := TO_NUMBER(RETORNA_NOVO_CODIGO('VERCARDACLI', 1));
			INSERT INTO VERCARDACLI
			(NRVERCARDACLI, NRVERCARDADIA, CDCLIENTE, CDFILIAL, 
			 CDDESTFILI, QTCOMESTICLI, 
			 NRORG, NRORGINCLUSAO, NRORGULTATU,
			 CDOPERINCLUSAO, CDOPERULTATU,
			 DTINCLUSAO, DTULTATU)
			VALUES
			(V_NRVERCARDACLI, V_NRVERCARDADIA, C_CARDACLI.CDCLIENTE, C_CARDACLI.CDFILIAL, 
			 C_CARDACLI.CDDESTFILI, C_CARDACLI.QTCOMESTICLI,
			 P_NRORG, P_NRORG, P_NRORG,
	       P_CDOPERADOR, P_CDOPERADOR,
	       SYSDATE, SYSDATE);
		END LOOP;

		-- Verifica se  feriado
      SELECT COUNT(*)
        INTO V_QTDE
      FROM FERIFILI
      WHERE CDFILIAL = C_CARDADIA.CDFILIAL AND
            DTFERIFILI = C_CARDADIA.DTCARDAPIO;
		-- Abre o cursor do consumo
		UTIL_CONSPLAN_PLA.OPEN_CONSSERV_CURSOR(CUR_CONSSERV,
                                             C_CARDADIA.CDFILIAL,
                                             C_CARDADIA.CDSERVFILI,
                                             C_CARDADIA.DTCARDAPIO,
                                             V_QTDE,
                                             '0',
                                             'zzzzzzzzzzzzzzzzzzzz',
                                             'T');
      LOOP
         FETCH CUR_CONSSERV INTO REC_CONSSERV;
         EXIT WHEN CUR_CONSSERV%NOTFOUND;

         V_NRVERCONSSERV := TO_NUMBER(RETORNA_NOVO_CODIGO('VERCONSSERV', 1));

			INSERT INTO VERCONSSERV
			(NRVERCONSSERV, NRVERCARDADIA, IDTIPOCONSUMO, 
			 CDPRODUTO, QTPRODUTO, 
			 NRORG, NRORGINCLUSAO, NRORGULTATU,
			 CDOPERINCLUSAO, CDOPERULTATU,
			 DTINCLUSAO, DTULTATU)
			VALUES
			(V_NRVERCONSSERV, V_NRVERCARDADIA, REC_CONSSERV.IDQTDECONS,
			 REC_CONSSERV.CDPRODUTO, REC_CONSSERV.QTCONSSERV,
			 P_NRORG, P_NRORG, P_NRORG,
	       P_CDOPERADOR, P_CDOPERADOR,
	       SYSDATE, SYSDATE);
		END LOOP;
		CLOSE CUR_CONSSERV;
		
		FOR C_COMP IN
		(
			SELECT CDFILAUXPRAT, CDPRATO, 
			       VRPECONSCARD, NRSEQPRATCAR, 
			       CDTIPOPRAT, QTCOMEFETPRA
			  FROM COMPCARD
			 WHERE CDFILIAL = C_CARDADIA.CDFILIAL
			   AND NRCARDAPIO = C_CARDADIA.NRCARDAPIO
		) LOOP
			V_NRVERCOMPCARD := TO_NUMBER(RETORNA_NOVO_CODIGO('VERCOMPCARD', 1));
			
			SELECT MAX(NRVERCNFCAMES)
			  INTO V_NRVERCNFCAMES
			  FROM VERCNFCAMES
			 WHERE NRVERCARDAMES = V_NRVERCARDAMES
			   AND NRSEQCNFMES = C_COMP.NRSEQPRATCAR;
			IF V_NRVERCNFCAMES IS NULL THEN
				CONTINUE;
			END IF;

			INSERT INTO VERCOMPCARD
			(NRVERCOMPCARD, NRVERCARDAMES, NRVERCARDADIA, 
			 NRVERCNFCAMES, CDFILAUXPRAT, CDPRATO, CDTIPOPRAT, 
			 VRPECONSCARD, QTCOMEFETPRA,
			 CDFILIAL, NRCARDAPIO, NRSEQPRATCAR,
			 NRORG, NRORGINCLUSAO, NRORGULTATU,
			 CDOPERINCLUSAO, CDOPERULTATU,
			 DTINCLUSAO, DTULTATU)
			VALUES
			(V_NRVERCOMPCARD, V_NRVERCARDAMES, V_NRVERCARDADIA,
			 V_NRVERCNFCAMES, C_COMP.CDFILAUXPRAT, C_COMP.CDPRATO, C_COMP.CDTIPOPRAT,
			 C_COMP.VRPECONSCARD, C_COMP.QTCOMEFETPRA,
			 C_CARDADIA.CDFILIAL, C_CARDADIA.NRCARDAPIO, C_COMP.NRSEQPRATCAR,
			 P_NRORG, P_NRORG, P_NRORG,
	       P_CDOPERADOR, P_CDOPERADOR,
	       SYSDATE, SYSDATE);

			
	      SELECT COUNT(1)
	        INTO V_QTDE
	        FROM VERRECEPRATOCAR
	       WHERE NRVERCARDAMES = V_NRVERCARDAMES
	         AND CDFILAUXPRAT = C_COMP.CDFILAUXPRAT
	         AND CDPRATO = C_COMP.CDPRATO;
	      -- Insere receita do prato se ela ainda no existir na verso salva
	      IF V_QTDE = 0 THEN
	      	V_IDTIPORECE := RECEITA_UTILIZADA(C_COMP.CDPRATO, C_COMP.CDFILAUXPRAT, 
	      		                               C_CARDADIA.CDFILIAL, C_CARDADIA.CDSERVFILI);

	      	FOR C_PRODRECE IN
	      	(
	      		SELECT CDPRODUTO,
	                   QTPRODPRAT AS QTPRODREC, VRPEFATCOCPR AS VRPEFATCOC, VRPEFATCORPR AS VRPEFATCOR,
	                   SGUNIDADE, QTBRUTAPRUNR AS QTBRUTAUNR,
	                   IDPRODBASEPR AS IDPRODBASE, IDQTDEFIXPR AS IDQTDEFIX
	      		  FROM RECEPADR
	      		 WHERE CDFILAUXPRAT = C_COMP.CDFILAUXPRAT
	      		   AND CDPRATO = C_COMP.CDPRATO
	      		   AND V_IDTIPORECE = 'P'
	      		UNION ALL
	      		SELECT CDPRODUTO,
	                   QTPRODRECLOC AS QTPRODREC, VRPEFATCOCLO AS VRPEFATCOC, VRPEFATCORLO AS VRPEFATCOR,
	                   SGUNIDADE, QTBRUTALOUNR AS QTBRUTAUNR, 
	                   IDPRODBASELO AS IDPRODBASE, IDQTDEFIXLO AS IDQTDEFIX
	      		  FROM RECEFILI
	      		 WHERE CDFILAUXPRAT = C_COMP.CDFILAUXPRAT
	      		   AND CDPRATO = C_COMP.CDPRATO
	      		   AND CDFILIAL = C_CARDADIA.CDFILIAL
	      		   AND V_IDTIPORECE = 'F'
	      		UNION ALL
	      		SELECT CDPRODUTO,
	                   QTPRODRECSER AS QTPRODREC, VRPEFATCOCSE AS VRPEFATCOC, VRPEFATCORSE AS VRPEFATCOR,
	                   SGUNIDADE, QTBRUTASEUNR AS QTBRUTAUNR, 
	                   IDPRODBASESE AS IDPRODBASE, IDQTDEFIXSE AS IDQTDEFIX
	      		  FROM RECESERV
	      		 WHERE CDFILAUXPRAT = C_COMP.CDFILAUXPRAT
	      		   AND CDPRATO = C_COMP.CDPRATO
	      		   AND CDFILIAL = C_CARDADIA.CDFILIAL
	      		   AND CDSERVFILI = C_CARDADIA.CDSERVFILI
	      		   AND V_IDTIPORECE = 'S'

	      	) LOOP
					V_SGUNIDADE := C_PRODRECE.SGUNIDADE;
					IF V_SGUNIDADE IS NULL THEN
						SELECT MAX(SGUNIDADE)
						  INTO V_SGUNIDADE
						  FROM PRODUTO
						 WHERE CDPRODUTO = C_PRODRECE.CDPRODUTO;
					END IF;

               V_NRVERRECEPRATOCAR := TO_NUMBER(RETORNA_NOVO_CODIGO('VERRECEPRATOCAR', 1));

					-- Insere receita do prato
					INSERT INTO VERRECEPRATOCAR
	            (NRVERRECEPRATOCAR, NRVERCARDAMES, 
	             CDFILAUXPRAT, CDPRATO,
	             CDPRODUTO, IDTIPORECE,
	             QTPRODREC, VRPEFATCOC, VRPEFATCOR,
	             SGUNIDADE, QTBRUTAUNR, 
	             IDPRODBASE, IDQTDEFIX,
	             NRORG, NRORGINCLUSAO, NRORGULTATU,
			       CDOPERINCLUSAO, CDOPERULTATU,
			       DTINCLUSAO, DTULTATU)
	             VALUES
	             (V_NRVERRECEPRATOCAR, V_NRVERCARDAMES,
					  C_COMP.CDFILAUXPRAT, C_COMP.CDPRATO,
					  C_PRODRECE.CDPRODUTO, V_IDTIPORECE, 
	              C_PRODRECE.QTPRODREC, NVL(C_PRODRECE.VRPEFATCOC, 0), NVL(C_PRODRECE.VRPEFATCOR, 0), 
	              V_SGUNIDADE, C_PRODRECE.QTBRUTAUNR,
	              NVL(C_PRODRECE.IDPRODBASE, 'N'), NVL(C_PRODRECE.IDQTDEFIX, 'N'),
	              P_NRORG, P_NRORG, P_NRORG,
		           P_CDOPERADOR, P_CDOPERADOR,
		           SYSDATE, SYSDATE);	         	

	      	END LOOP;
	      	
			END IF;
			
		END LOOP;		
	END LOOP;		
	-- Percorre cada produto distinto existente no cardpio e registra seu custo na tabela
	FOR C_PROD IN
	(
      SELECT DISTINCT CDPRODUTO
        FROM VERRECEPRATOCAR
       WHERE NRVERCARDAMES = V_NRVERCARDAMES
      UNION
      SELECT DISTINCT CDPRODUTO
        FROM VERCARDADIA VD
             INNER JOIN VERCONSSERV VCS ON VD.NRVERCARDADIA = VCS.NRVERCARDADIA
       WHERE VD.NRVERCARDAMES = V_NRVERCARDAMES
	) LOOP
		V_NRVERCUSTOPRODUTOCAR := TO_NUMBER(RETORNA_NOVO_CODIGO('VERCUSTOPRODUTOCAR', 1));
		V_VRCUSTO := CUSTO_PRODUTO(P_CDFILIAL, C_PROD.CDPRODUTO, TO_NUMBER(P_CDTIPOCUSTO), P_DTREFECUSTO, P_DTREFECUSTO);
		V_VRCUSTO := NVL(V_VRCUSTO, 0);
		
		INSERT INTO VERCUSTOPRODUTOCAR
      (NRVERCUSTOPRODUTOCAR, NRVERCARDAMES, CDPRODUTO, VRCUSTO,
	    NRORG, NRORGINCLUSAO, NRORGULTATU,
		 CDOPERINCLUSAO, CDOPERULTATU,
		 DTINCLUSAO, DTULTATU)
     	VALUES
     	(V_NRVERCUSTOPRODUTOCAR, V_NRVERCARDAMES, C_PROD.CDPRODUTO, V_VRCUSTO,
     	 P_NRORG, P_NRORG, P_NRORG,
		 P_CDOPERADOR, P_CDOPERADOR,
		 SYSDATE, SYSDATE);
	END LOOP;	
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_HISTCARDAMES','0.00.000'); END;
/