/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8949_SUPSTPS.sql                         

Descrio:
Remaneja solicitaes das filiais de acordo com o arredondamento para empenho do OL.

Criao:
20/08/2007 - Marcelo Alexsandro Souza Silva
*/

IF EXISTS (SELECT * FROM sysobjects O, sysusers U
          WHERE                                   
            o.name = 'EMPENHO_OL'  and
            type = 'P'                    and
            u.uid = o.uid                 and
            u.name = USER)
   DROP PROCEDURE EMPENHO_OL;
GO

CREATE PROCEDURE EMPENHO_OL
   @P_NRSEQCONSOL  VARCHAR(10),
   @P_CDFILIOPELOG VARCHAR(4),
   @P_CDFILSOLI    VARCHAR(4),
   @P_CDPRODESTO   VARCHAR(10),
   @P_CDOPERADOR   VARCHAR(12),
   @P_NRNECECOMP   VARCHAR(10)
AS

DECLARE @V_NRSOLCOMP      VARCHAR(200);
DECLARE @W_S              VARCHAR(1);
DECLARE @W_N              VARCHAR(1);
DECLARE @V_QTDERESTANTE   DOUBLE PRECISION;
DECLARE @V_VRARREDEMPE    DOUBLE PRECISION;
DECLARE @V_QTARRED        DOUBLE PRECISION;
DECLARE @V_QTAEMPENHAR    DOUBLE PRECISION;
DECLARE @V_QTDEAUX        DOUBLE PRECISION;
DECLARE @V_QTDECONS       DOUBLE PRECISION;
DECLARE @V_QTDEAPAGARELAC DOUBLE PRECISION;
DECLARE @V_CDFORNEOL      VARCHAR(21);
DECLARE @V_QTDERETIRARSOL DOUBLE PRECISION;
DECLARE @V_QTDETOTALCONS  DOUBLE PRECISION;
DECLARE @V_QTDEJARETIRADA DOUBLE PRECISION;
DECLARE @V_QTDETOTALSOL   DOUBLE PRECISION;
DECLARE @V_VRFATOCONV     DOUBLE PRECISION;
DECLARE @V_VRARREDCMP     DOUBLE PRECISION;
DECLARE @V_QTDESOLDEPOIS  DOUBLE PRECISION;
DECLARE @V_QTDERESTSOL    DOUBLE PRECISION;
DECLARE @V_COUNT          DOUBLE PRECISION;
DECLARE @V_COMPARAQTDE    DOUBLE PRECISION;

DECLARE @V_ITEMCONSSOLOL_CDFILLAN     VARCHAR(4);
DECLARE @V_ITEMCONSSOLOL_CDPRODUTO    VARCHAR(10);
DECLARE @V_ITEMCONSSOLOL_DTENTRCONSOL DATETIME;
DECLARE @V_ITEMCONSSOLOL_QTENTRCONSOL DOUBLE PRECISION;
DECLARE @V_ITEMCONSSOLOL_VRFATOCONV   DOUBLE PRECISION;
DECLARE @V_ITEMCONSSOLOL_VRARREDCMP   DOUBLE PRECISION;

DECLARE @V_APAGARELACONSSOL_QTENTRCONS DOUBLE PRECISION;
DECLARE @V_APAGARELACONSSOL_DTPROGENTR DATETIME;

DECLARE @V_DELETEITEMSOLI_CDFILSOLI    VARCHAR(4);
DECLARE @V_DELETEITEMSOLI_CDFILLAN     VARCHAR(4);
DECLARE @V_DELETEITEMSOLI_NRSOLICMP    VARCHAR(10);
DECLARE @V_DELETEITEMSOLI_CDPRODUTO    VARCHAR(10);
DECLARE @V_DELETEITEMSOLI_DTPROGENTR   DATETIME;
DECLARE @V_DELETEITEMSOLI_QTSOLIPROD   DOUBLE PRECISION;

DECLARE @V_ITEMSOLI_QTDE               DOUBLE PRECISION;
DECLARE @V_ITEMSOLI_CDPRODESTO         VARCHAR(10);
DECLARE @V_ITEMSOLI_CDFILLANCONS       VARCHAR(4);
DECLARE @V_ITEMSOLI_DTENTRCONSOL       DATETIME;
DECLARE @V_ITEMSOLI_DTPROGENTR         DATETIME;

DECLARE @V_ITEM_NRSOLICMP              VARCHAR(10);
DECLARE @V_ITEM_CDFILLAN               VARCHAR(4);
DECLARE @V_ITEM_CDPRODUTO              VARCHAR(10);
DECLARE @V_ITEM_DTPROGENTR             DATETIME;

DECLARE @V_ITEMSOLI_FINAL_CDFILSOLI    VARCHAR(4);
DECLARE @V_ITEMSOLI_FINAL_CDFILLAN     VARCHAR(4);
DECLARE @V_ITEMSOLI_FINAL_NRSOLICMP    VARCHAR(10);
DECLARE @V_ITEMSOLI_FINAL_CDPRODUTO    VARCHAR(10);
DECLARE @V_ITEMSOLI_FINAL_DTPROGENTR   DATETIME;
DECLARE @V_ITEMSOLI_FINAL_QTSOLIPROD   DOUBLE PRECISION;
DECLARE @V_ITEMSOLI_FINAL_VRARREDCMP   DOUBLE PRECISION;
DECLARE @V_ITEMSOLI_FINAL_VRFATOCONV   DOUBLE PRECISION;
DECLARE @V_ITEMSOLI_AUX_QTSOLIPROD     DOUBLE PRECISION;

DECLARE @V_REJEICAOOL                  FLOAT; /* PORCENTAGEM DE REJEIO*/
DECLARE @V_VRFATCONVOL                 NUMERIC;
DECLARE @V_QTDFINAL                    NUMERIC;

DECLARE @C_ITEMCONS_CDPRODUTO          VARCHAR(20);
DECLARE @C_ITEMCONS_NRSEQUCONSOL       VARCHAR(20);
DECLARE @C_ITEMCONS_CDFILSOLI          VARCHAR(04);
DECLARE @C_ITEMCONS_CDFILLAN           VARCHAR(04);
DECLARE @C_ITEMCONS_DTENTRCONSOL       DATETIME;

BEGIN
   SET @W_S = 'S';
   SET @W_N = 'N';
   SET @V_QTAEMPENHAR = 0;
   SELECT
      @V_CDFORNEOL = MAX(CDFORNOPELOG)
   FROM
      FILIAL
   WHERE
      FILIAL.CDFILIAL = @P_CDFILIOPELOG;

   IF @P_NRNECECOMP IS NULL BEGIN
      SELECT @V_QTDETOTALCONS = SUM(RE.QTENTRCONS*ISNULL(RE.VRFATOCONV, 1))
      FROM
        (SELECT DISTINCT
           NRSEQUCONSOL,
           CDPRODUTOCONS,
           CDFILSOLCONS,
           CDFILLANCONS,
           DTENTRCONSOL,
           VRFATOCONV,
           QTENTRCONS,
           DTPROGENTR
         FROM
           RELACONSOLOL R, PRODUTO P
         WHERE R.NRSEQUCONSOL = @P_NRSEQCONSOL
          AND R.CDFILSOLCONS = @P_CDFILIOPELOG
          AND P.CDPRODESTO   = @P_CDPRODESTO
          AND R.CDFILSOLI    = @P_CDFILSOLI
          AND P.CDPRODUTO    = R.CDPRODUTOCONS) RE;

      SELECT
         @V_QTDETOTALSOL = SUM(IT.QTSOLIPROD*ISNULL(PR.VRFATOCONV, 1))
      FROM
         ITEMSOLI IT, PRODUTO PR
      WHERE IT.CDFILSOLI                 = @P_CDFILSOLI
        AND PR.CDPRODESTO                = @P_CDPRODESTO
        AND PR.CDPRODUTO                 = IT.CDPRODUTO
        AND IT.CDFILSOLI                <> @P_CDFILIOPELOG
        AND ISNULL(IT.IDSOLIAPROV, @W_S) = @W_S
        AND ISNULL(IT.IDITMCONS, @W_N)   = @W_N
        AND IT.CDFILIOPELOG              = @P_CDFILIOPELOG
        AND IT.NRSEQUCONSOL              = @P_NRSEQCONSOL;
   END
   ELSE BEGIN
      SELECT @V_QTDETOTALCONS = SUM(RE.QTENTRCONS*ISNULL(RE.VRFATOCONV, 1))
      FROM
        (SELECT DISTINCT
           NRSEQUCONSOL,
           CDPRODUTOCONS,
           CDFILSOLCONS,
           CDFILLANCONS,
           DTENTRCONSOL,
           VRFATOCONV,
           QTNCPREVCONSOL QTENTRCONS,
           DTNCPREVCONSOL
         FROM
           RELACONSOLOLNC R, PRODUTO P
         WHERE R.NRSEQUCONSOL  = @P_NRSEQCONSOL
          AND R.CDFILSOLCONS   = @P_CDFILIOPELOG
          AND P.CDPRODESTO     = @P_CDPRODESTO
          AND R.CDFILIAL       = @P_CDFILSOLI
          AND R.NRNCPREVCONSOL = @P_NRNECECOMP
         AND P.CDPRODUTO       = R.CDPRODUTOCONS) RE;

      SELECT
         @V_QTDETOTALSOL = SUM(IT.QTPRCNVCOMPR * ISNULL(PR.VRFATOCONV, 1))
      FROM
         TRABNECECOMP IT, PRODUTO PR
      WHERE IT.CDFILNECECMP          = @P_CDFILSOLI
        AND PR.CDPRODESTO            = @P_CDPRODESTO
        AND IT.NRNECECOMP            = @P_NRNECECOMP
        AND PR.CDPRODUTO             = IT.CDPRODNECCMP
        AND IT.CDFILNECECMP          <> @P_CDFILIOPELOG
        AND IT.CDFILIOPELOG          = @P_CDFILIOPELOG
        AND IT.IDMARCNECCMP          = @W_S;
   END;

   SET @V_QTAEMPENHAR = @V_QTDETOTALCONS - @V_QTDETOTALSOL;
   SET @V_QTDEJARETIRADA = 0;
   SET @V_QTDERESTANTE = @V_QTAEMPENHAR;

   IF @V_QTDERESTANTE > 0 BEGIN
      /*Lida com os itens consolidados*/
      DECLARE C_ITEMCONSSOLOL CURSOR FOR
         SELECT
            ITEMCONSSOLOL.CDFILLAN,
            ITEMCONSSOLOL.CDPRODUTO,
            ITEMCONSSOLOL.DTENTRCONSOL,
            ITEMCONSSOLOL.QTENTRCONSOL,
            ISNULL(PRODUTO.VRFATOCONV, 1) VRFATOCONV,
            ISNULL(PRODUTO.VRARREDCMP, 0) VRARREDCMP
         FROM ITEMCONSSOLOL, PRODUTO
         WHERE PRODUTO.CDPRODESTO = @P_CDPRODESTO
           AND ITEMCONSSOLOL.CDPRODUTO = PRODUTO.CDPRODUTO
           AND ITEMCONSSOLOL.NRSEQUCONSOL = @P_NRSEQCONSOL
         ORDER BY
            ITEMCONSSOLOL.DTENTRCONSOL DESC,
            PRODUTO.VRFATOCONV DESC,
            PRODUTO.VRARREDCMP DESC
      OPEN C_ITEMCONSSOLOL;
      FETCH NEXT FROM C_ITEMCONSSOLOL INTO @V_ITEMCONSSOLOL_CDFILLAN,
                                           @V_ITEMCONSSOLOL_CDPRODUTO,
                                           @V_ITEMCONSSOLOL_DTENTRCONSOL,
                                           @V_ITEMCONSSOLOL_QTENTRCONSOL,
                                           @V_ITEMCONSSOLOL_VRFATOCONV,
                                           @V_ITEMCONSSOLOL_VRARREDCMP;
      WHILE (@@FETCH_STATUS = 0) BEGIN
         SELECT @V_VRARREDEMPE = MAX(VRARREDEMPE)
         FROM PRODFORNCOMP
         WHERE PRODFORNCOMP.CDFORNECED = @V_CDFORNEOL
           AND PRODFORNCOMP.CDPRODCOMPL IN (SELECT CDPRODUTO FROM PRODUTO WHERE CDPRODESTO = @P_CDPRODESTO);
         IF (@V_VRARREDEMPE > 0) AND (@V_QTDERESTANTE > 0) BEGIN
            IF (@V_ITEMCONSSOLOL_VRFATOCONV*@V_ITEMCONSSOLOL_QTENTRCONSOL) <= @V_QTDERESTANTE BEGIN
               IF @V_QTDETOTALCONS > ((@V_ITEMCONSSOLOL_VRFATOCONV*@V_ITEMCONSSOLOL_QTENTRCONSOL) + @V_QTDEJARETIRADA)
               BEGIN
                  DELETE FROM ITEMCONSSOLOL
                  WHERE NRSEQUCONSOL = @P_NRSEQCONSOL
                    AND CDFILSOLI = @P_CDFILIOPELOG
                    AND CDFILLAN = @V_ITEMCONSSOLOL_CDFILLAN
                    AND CDPRODUTO = @V_ITEMCONSSOLOL_CDPRODUTO
                    AND DTENTRCONSOL = @V_ITEMCONSSOLOL_DTENTRCONSOL;
                  SET @V_QTDEJARETIRADA = @V_QTDEJARETIRADA + (@V_ITEMCONSSOLOL_VRFATOCONV*@V_ITEMCONSSOLOL_QTENTRCONSOL);
                  SET @V_QTDERESTANTE = @V_QTDERESTANTE - (@V_ITEMCONSSOLOL_VRFATOCONV*@V_ITEMCONSSOLOL_QTENTRCONSOL);
               END;
            END
            ELSE BEGIN
               SET @V_QTARRED = (@V_QTDERESTANTE/@V_ITEMCONSSOLOL_VRFATOCONV);
               IF @V_ITEMCONSSOLOL_VRARREDCMP > 0 BEGIN
                  SET @V_QTARRED = FLOOR(@V_QTARRED / @V_ITEMCONSSOLOL_VRARREDCMP) * @V_ITEMCONSSOLOL_VRARREDCMP; /* TEM QUE ARREDONDAR PARA BAIXO PARA NAO TIRAR MAIS DO QUE DEVIA */
               END;
               IF @V_VRARREDEMPE > 0 BEGIN
                  SET @V_QTARRED = FLOOR(@V_QTARRED / @V_VRARREDEMPE) * @V_VRARREDEMPE; /* TEM QUE ARREDONDAR PARA BAIXO PARA NAO TIRAR MAIS DO QUE DEVIA */
               END;
               IF @V_QTDETOTALCONS > ((@V_ITEMCONSSOLOL_VRFATOCONV*@V_QTARRED) + @V_QTDEJARETIRADA)
               BEGIN
                  IF @V_QTARRED > 0 BEGIN
                     IF @V_QTARRED < @V_ITEMCONSSOLOL_QTENTRCONSOL BEGIN
                        SET @V_QTDEAPAGARELAC = @V_QTARRED;
                        IF @P_NRNECECOMP IS NULL BEGIN
                           DECLARE C_APAGARELACONSSOL CURSOR FOR
                               SELECT DISTINCT
                                  QTENTRCONS, DTPROGENTR
                               FROM RELACONSOLOL
                               WHERE NRSEQUCONSOL = @P_NRSEQCONSOL
                                 AND CDPRODUTOCONS = @V_ITEMCONSSOLOL_CDPRODUTO
                                 AND CDFILSOLCONS = @P_CDFILIOPELOG
                                 AND CDFILSOLI = @P_CDFILSOLI
                                 AND CDFILLANCONS = @V_ITEMCONSSOLOL_CDFILLAN
                                 AND DTENTRCONSOL = @V_ITEMCONSSOLOL_DTENTRCONSOL
                               ORDER BY
                                  DTPROGENTR DESC,
                                  QTENTRCONS DESC
                        END
                        ELSE BEGIN
                           DECLARE C_APAGARELACONSSOL CURSOR FOR
                               SELECT DISTINCT
                                  QTNCPREVCONSOL, DTNCPREVCONSOL
                               FROM RELACONSOLOLNC
                               WHERE NRSEQUCONSOL   = @P_NRSEQCONSOL
                                 AND CDPRODUTOCONS  = @V_ITEMCONSSOLOL_CDPRODUTO
                                 AND CDFILSOLCONS   = @P_CDFILIOPELOG
                                 AND CDFILLANCONS   = @V_ITEMCONSSOLOL_CDFILLAN
                                 AND DTENTRCONSOL   = @V_ITEMCONSSOLOL_DTENTRCONSOL
                                 AND NRNCPREVCONSOL = @P_NRNECECOMP
                                 AND CDFILIAL       = @P_CDFILSOLI
                               ORDER BY
                                  DTNCPREVCONSOL DESC,
                                  QTNCPREVCONSOL DESC
                        END;
                        OPEN C_APAGARELACONSSOL;
                        FETCH NEXT FROM C_APAGARELACONSSOL INTO @V_APAGARELACONSSOL_QTENTRCONS,
                                                                @V_APAGARELACONSSOL_DTPROGENTR;
                        WHILE (@@FETCH_STATUS = 0) BEGIN
                           IF @V_QTDEAPAGARELAC > 0 BEGIN
                              IF (@V_APAGARELACONSSOL_QTENTRCONS <= @V_QTDEAPAGARELAC) BEGIN
                                 IF @P_NRNECECOMP IS NULL BEGIN
                                    DELETE FROM RELACONSOLOL
                                    WHERE NRSEQUCONSOL = @P_NRSEQCONSOL
                                      AND CDPRODUTOCONS = @V_ITEMCONSSOLOL_CDPRODUTO
                                      AND CDFILSOLCONS = @P_CDFILIOPELOG
                                      AND CDFILSOLI = @P_CDFILSOLI
                                      AND CDFILLANCONS = @V_ITEMCONSSOLOL_CDFILLAN
                                      AND DTENTRCONSOL = @V_ITEMCONSSOLOL_DTENTRCONSOL
                                      AND DTPROGENTR = @V_APAGARELACONSSOL_DTPROGENTR
                                      AND QTENTRCONS = @V_APAGARELACONSSOL_QTENTRCONS;
                                 END
                                 ELSE BEGIN
                                    DELETE FROM RELACONSOLOLNC
                                    WHERE NRSEQUCONSOL  = @P_NRSEQCONSOL
                                      AND CDPRODUTOCONS = @V_ITEMCONSSOLOL_CDPRODUTO
                                      AND CDFILSOLCONS   = @P_CDFILIOPELOG
                                      AND CDFILIAL       = @P_CDFILSOLI
                                      AND NRNCPREVCONSOL = @P_NRNECECOMP
                                      AND CDFILLANCONS   = @V_ITEMCONSSOLOL_CDFILLAN
                                      AND DTENTRCONSOL   = @V_ITEMCONSSOLOL_DTENTRCONSOL
                                      AND DTNCPREVCONSOL = @V_APAGARELACONSSOL_DTPROGENTR
                                      AND QTNCPREVCONSOL = @V_APAGARELACONSSOL_QTENTRCONS;
                                 END;
                                 SET @V_QTDEAPAGARELAC = @V_QTDEAPAGARELAC - @V_APAGARELACONSSOL_QTENTRCONS;
                              END
                              ELSE BEGIN
                                 UPDATE RELACONSOLOLNC
                                 SET QTNCPREVCONSOL   = QTNCPREVCONSOL - @V_QTDEAPAGARELAC
                                 WHERE NRSEQUCONSOL   = @P_NRSEQCONSOL
                                   AND CDPRODUTOCONS  = @V_ITEMCONSSOLOL_CDPRODUTO
                                   AND CDFILSOLCONS   = @P_CDFILIOPELOG
                                   AND CDFILIAL       = @P_CDFILSOLI
                                   AND NRNCPREVCONSOL = @P_NRNECECOMP
                                   AND CDFILLANCONS   = @V_ITEMCONSSOLOL_CDFILLAN
                                   AND DTENTRCONSOL   = @V_ITEMCONSSOLOL_DTENTRCONSOL
                                   AND DTNCPREVCONSOL = @V_APAGARELACONSSOL_DTPROGENTR
                                   AND QTNCPREVCONSOL = @V_APAGARELACONSSOL_QTENTRCONS;
                                 SET @V_QTDEAPAGARELAC = 0;
                              END;
                           END;
                           FETCH NEXT FROM C_APAGARELACONSSOL INTO @V_APAGARELACONSSOL_QTENTRCONS,
                                                                   @V_APAGARELACONSSOL_DTPROGENTR;
                        END;
                        CLOSE C_APAGARELACONSSOL;
                        DEALLOCATE C_APAGARELACONSSOL;

                        UPDATE ITEMCONSSOLOL
                        SET QTENTRCONSOL = QTENTRCONSOL - @V_QTARRED
                        WHERE NRSEQUCONSOL = @P_NRSEQCONSOL
                          AND CDFILSOLI = @P_CDFILIOPELOG
                          AND CDFILLAN = @V_ITEMCONSSOLOL_CDFILLAN
                          AND CDPRODUTO = @V_ITEMCONSSOLOL_CDPRODUTO
                          AND DTENTRCONSOL = @V_ITEMCONSSOLOL_DTENTRCONSOL;
                        SET @V_QTDEJARETIRADA = @V_QTDEJARETIRADA + (@V_QTARRED*@V_ITEMCONSSOLOL_VRFATOCONV);
                        SET @V_QTDERESTANTE = @V_QTDERESTANTE - (@V_ITEMCONSSOLOL_VRFATOCONV*@V_QTARRED);
                     END;
                  END;
               END;
            END;
         END;
         FETCH NEXT FROM C_ITEMCONSSOLOL INTO @V_ITEMCONSSOLOL_CDFILLAN,
                                              @V_ITEMCONSSOLOL_CDPRODUTO,
                                              @V_ITEMCONSSOLOL_DTENTRCONSOL,
                                              @V_ITEMCONSSOLOL_QTENTRCONSOL,
                                              @V_ITEMCONSSOLOL_VRFATOCONV,
                                              @V_ITEMCONSSOLOL_VRARREDCMP;
      END;
      CLOSE C_ITEMCONSSOLOL;
      DEALLOCATE C_ITEMCONSSOLOL;

      IF @P_NRNECECOMP IS NULL BEGIN

         /*Apaga as solicitaes cujos itens consolidados no mais existem*/
         DECLARE C_DELETEITEMSOLI CURSOR FOR
            SELECT
               ITEMSOLI.CDFILSOLI,
               ITEMSOLI.CDFILLAN,
               ITEMSOLI.NRSOLICMP,
               ITEMSOLI.CDPRODUTO,
               ITEMSOLI.DTPROGENTR,
               ITEMSOLI.QTSOLIPROD
            FROM ITEMSOLI
            WHERE ITEMSOLI.CDFILSOLI = @P_CDFILSOLI
              AND ITEMSOLI.NRSEQUCONSOL = @P_NRSEQCONSOL
              AND EXISTS (SELECT 1
                          FROM PRODUTO
                          WHERE PRODUTO.CDPRODESTO = @P_CDPRODESTO
                            AND PRODUTO.CDPRODUTO = ITEMSOLI.CDPRODUTO)
              AND NOT EXISTS (SELECT 1
                              FROM RELACONSOLOL R
                              WHERE R.CDFILSOLI = ITEMSOLI.CDFILSOLI
                                AND R.CDFILLAN = ITEMSOLI.CDFILLAN
                                AND R.NRSOLICMP = ITEMSOLI.NRSOLICMP
                                AND R.CDPRODUTO = ITEMSOLI.CDPRODUTO
                                AND R.DTPROGENTR = ITEMSOLI.DTPROGENTR
                                AND R.NRSEQUCONSOL = ITEMSOLI.NRSEQUCONSOL)
         OPEN C_DELETEITEMSOLI;
         FETCH NEXT FROM C_DELETEITEMSOLI INTO @V_DELETEITEMSOLI_CDFILSOLI,
                                               @V_DELETEITEMSOLI_CDFILLAN,
                                               @V_DELETEITEMSOLI_NRSOLICMP,
                                               @V_DELETEITEMSOLI_CDPRODUTO,
                                               @V_DELETEITEMSOLI_DTPROGENTR,
                                               @V_DELETEITEMSOLI_QTSOLIPROD;
         WHILE (@@FETCH_STATUS = 0) BEGIN
            /* Log de Alterao */
            INSERT INTO MOVOPSOL
              (CDFILSOLMOV,
               CDFILLANMOV,
               NRSOLIMOV,
               CDPRODUTO,
               DTENTROPER,
               DTOPERSOL,
               CDOPERADOR,
               QTANTOPER,
               QTDEPOPER,
               DSJUSTOPER)
            VALUES
              (@V_DELETEITEMSOLI_CDFILSOLI,
               @V_DELETEITEMSOLI_CDFILLAN,
               @V_DELETEITEMSOLI_NRSOLICMP,
               @V_DELETEITEMSOLI_CDPRODUTO,
               @V_DELETEITEMSOLI_DTPROGENTR,
               GETDATE(),
               @P_CDOPERADOR,
               @V_DELETEITEMSOLI_QTSOLIPROD,
               0,
               'Empenho de OL - Consol. Sem Item');

            INSERT INTO ITEMSOLIDEL
               (CDFILSOLI,
                CDFILLAN,
                NRSOLICMP,
                CDPRODUTO,
                DTPROGENTR,
                QTSOLIORIGDEL)
            SELECT
               @V_DELETEITEMSOLI_CDFILSOLI,
               @V_DELETEITEMSOLI_CDFILLAN,
               @V_DELETEITEMSOLI_NRSOLICMP,
               @V_DELETEITEMSOLI_CDPRODUTO,
               @V_DELETEITEMSOLI_DTPROGENTR,
               @V_DELETEITEMSOLI_QTSOLIPROD
            WHERE
            NOT EXISTS
                (SELECT (1)
                   FROM ITEMSOLIDEL
                  WHERE CDFILSOLI  =  @V_DELETEITEMSOLI_CDFILSOLI
                    AND CDFILLAN   =  @V_DELETEITEMSOLI_CDFILLAN
                    AND NRSOLICMP  =  @V_DELETEITEMSOLI_NRSOLICMP
                    AND CDPRODUTO  =  @V_DELETEITEMSOLI_CDPRODUTO
                    AND DTPROGENTR =  @V_DELETEITEMSOLI_DTPROGENTR);

            DELETE FROM ITEMSOLI
            WHERE @V_DELETEITEMSOLI_CDFILSOLI = ITEMSOLI.CDFILSOLI
              AND @V_DELETEITEMSOLI_CDFILLAN = ITEMSOLI.CDFILLAN
              AND @V_DELETEITEMSOLI_NRSOLICMP = ITEMSOLI.NRSOLICMP
              AND @V_DELETEITEMSOLI_CDPRODUTO = ITEMSOLI.CDPRODUTO
              AND @V_DELETEITEMSOLI_DTPROGENTR = ITEMSOLI.DTPROGENTR
              AND @V_DELETEITEMSOLI_QTSOLIPROD = ITEMSOLI.QTSOLIPROD;

            FETCH NEXT FROM C_DELETEITEMSOLI INTO @V_DELETEITEMSOLI_CDFILSOLI,
                                                  @V_DELETEITEMSOLI_CDFILLAN,
                                                  @V_DELETEITEMSOLI_NRSOLICMP,
                                                  @V_DELETEITEMSOLI_CDPRODUTO,
                                                  @V_DELETEITEMSOLI_DTPROGENTR,
                                                  @V_DELETEITEMSOLI_QTSOLIPROD;
         END;
         CLOSE C_DELETEITEMSOLI;
         DEALLOCATE C_DELETEITEMSOLI;

         /*Manipula as solicitaes conforme a consolidao realizada*/
         DECLARE C_ITEMSOLI CURSOR FOR
             SELECT
               SUM(RE.QTENTRCONS*ISNULL(RE.VRFATOCONV, 1)) QTDE,
               RE.CDPRODESTO,
               RE.CDFILLANCONS,
               RE.DTENTRCONSOL,
               RE.DTPROGENTR
             FROM
              (SELECT DISTINCT
                 NRSEQUCONSOL,
                 CDPRODUTOCONS,
                 CDFILSOLCONS,
                 CDFILLANCONS,
                 CDPRODESTO,
                 DTENTRCONSOL,
                 VRFATOCONV,
                 QTENTRCONS,
                 DTPROGENTR
               FROM
                 RELACONSOLOL R, PRODUTO P
               WHERE R.NRSEQUCONSOL = @P_NRSEQCONSOL
                AND R.CDFILSOLCONS = @P_CDFILIOPELOG
                AND P.CDPRODESTO   = @P_CDPRODESTO
                AND R.CDFILSOLI    = @P_CDFILSOLI
                AND P.CDPRODUTO    = R.CDPRODUTOCONS) RE
             GROUP BY
               RE.CDPRODESTO,
               RE.CDFILLANCONS,
               RE.DTENTRCONSOL,
               RE.DTPROGENTR
             ORDER BY RE.DTENTRCONSOL DESC
         OPEN C_ITEMSOLI;
         FETCH NEXT FROM C_ITEMSOLI INTO @V_ITEMSOLI_QTDE,
                                         @V_ITEMSOLI_CDPRODESTO,
                                         @V_ITEMSOLI_CDFILLANCONS,
                                         @V_ITEMSOLI_DTENTRCONSOL,
                                         @V_ITEMSOLI_DTPROGENTR;
         WHILE (@@FETCH_STATUS = 0) BEGIN
            SELECT @V_VRARREDEMPE = MAX(VRARREDEMPE)
            FROM PRODFORNCOMP
            WHERE PRODFORNCOMP.CDFORNECED = @V_CDFORNEOL
              AND PRODFORNCOMP.CDPRODCOMPL IN (SELECT CDPRODUTO FROM PRODUTO WHERE CDPRODESTO = @V_ITEMSOLI_CDPRODESTO);
            IF (@V_VRARREDEMPE > 0) BEGIN
               SET @V_QTDECONS = @V_ITEMSOLI_QTDE;
               SELECT
                  @V_NRSOLCOMP = MIN(NRSOLICMP+CDFILLAN+RELACONSOLOL.CDPRODUTO+CONVERT(VARCHAR, RELACONSOLOL.DTPROGENTR, 112))
               FROM
                  RELACONSOLOL, PRODUTO
               WHERE NRSEQUCONSOL = @P_NRSEQCONSOL
                 AND CDPRODESTO = @V_ITEMSOLI_CDPRODESTO
                 AND PRODUTO.CDPRODUTO = RELACONSOLOL.CDPRODUTOCONS
                 AND CDFILSOLCONS = @P_CDFILIOPELOG
                 AND CDFILLANCONS = @V_ITEMSOLI_CDFILLANCONS
                 AND DTENTRCONSOL = @V_ITEMSOLI_DTENTRCONSOL
                 AND CDFILSOLI = @P_CDFILSOLI;

               SELECT
                  @V_VRFATOCONV = ISNULL(MAX(VRFATOCONV), 1),
                  @V_VRARREDCMP = ISNULL(MAX(VRARREDCMP), 0)
               FROM PRODUTO
               WHERE PRODUTO.CDPRODUTO = SUBSTRING(@V_NRSOLCOMP, 15, 10);

               SET @V_QTDEAUX = @V_QTDECONS/@V_VRFATOCONV;

               IF @V_VRARREDCMP > 0 BEGIN
                  SET @V_QTDEAUX = CEILING(CAST(@V_QTDEAUX AS DOUBLE PRECISION) / @V_VRARREDCMP) * @V_VRARREDCMP;
               END;

               SELECT
                  @V_COMPARAQTDE = ITEMSOLI.QTSOLIPROD
               FROM
                  ITEMSOLI
               WHERE
                  (ITEMSOLI.CDFILSOLI  = @P_CDFILSOLI)    AND
                  (ITEMSOLI.CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4))  AND
                  (ITEMSOLI.NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10))  AND
                  (ITEMSOLI.CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10)) AND
                  (ITEMSOLI.DTPROGENTR = CONVERT(DATETIME, SUBSTRING(@V_NRSOLCOMP, 25, 10), 112));

               IF @V_COMPARAQTDE < @V_QTDEAUX BEGIN
                  /* Log de Alterao */
                  INSERT INTO MOVOPSOL
                    (CDFILSOLMOV,
                     CDFILLANMOV,
                     NRSOLIMOV,
                     CDPRODUTO,
                     DTENTROPER,
                     DTOPERSOL,
                     CDOPERADOR,
                     QTANTOPER,
                     QTDEPOPER,
                     DSJUSTOPER)
                  SELECT
                     ITEMSOLI.CDFILSOLI,
                     ITEMSOLI.CDFILLAN,
                     ITEMSOLI.NRSOLICMP,
                     ITEMSOLI.CDPRODUTO,
                     ITEMSOLI.DTPROGENTR,
                     GETDATE(),
                     @P_CDOPERADOR,
                     ITEMSOLI.QTSOLIPROD,
                     @V_QTDEAUX,
                     'Empenho de OL - Conforme Cons.'
                  FROM
                     ITEMSOLI
                  WHERE
                     (ITEMSOLI.CDFILSOLI  = @P_CDFILSOLI)    AND
                     (ITEMSOLI.CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4))  AND
                     (ITEMSOLI.NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10))  AND
                     (ITEMSOLI.CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10)) AND
                     (ITEMSOLI.DTPROGENTR = CONVERT(DATETIME, SUBSTRING(@V_NRSOLCOMP, 25, 10), 112));

                  UPDATE ITEMSOLI
                  SET QTSOLIORIG = ISNULL(QTSOLIORIG, QTSOLIPROD),
                      QTSOLIPROD = @V_QTDEAUX
                  WHERE
                     (CDFILSOLI  = @P_CDFILSOLI)    AND
                     (CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4))  AND
                     (NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10))  AND
                     (CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10)) AND
                     (DTPROGENTR = CONVERT(DATETIME, SUBSTRING(@V_NRSOLCOMP, 25, 10), 112));

                  DECLARE C_ITEM CURSOR FOR
                     SELECT
                        NRSOLICMP,
                        CDFILLAN,
                        RELACONSOLOL.CDPRODUTO,
                        DTPROGENTR
                      FROM
                        RELACONSOLOL, PRODUTO
                      WHERE NRSEQUCONSOL = @P_NRSEQCONSOL
                        AND CDPRODUTOCONS = PRODUTO.CDPRODUTO
                        AND PRODUTO.CDPRODESTO = @V_ITEMSOLI_CDPRODESTO
                        AND CDFILSOLCONS = @P_CDFILIOPELOG
                        AND CDFILLANCONS = @V_ITEMSOLI_CDFILLANCONS
                        AND DTENTRCONSOL = @V_ITEMSOLI_DTENTRCONSOL
                        AND CDFILSOLI    = @P_CDFILSOLI
                        AND DTPROGENTR   = @V_ITEMSOLI_DTPROGENTR
                        AND ((CDFILLAN <> SUBSTRING(@V_NRSOLCOMP, 11, 4)) OR
                             (NRSOLICMP <> SUBSTRING(@V_NRSOLCOMP, 1, 10)) OR
                             (RELACONSOLOL.CDPRODUTO <> SUBSTRING(@V_NRSOLCOMP, 15, 10))
                            )
                  OPEN C_ITEM;
                  FETCH NEXT FROM C_ITEM INTO @V_ITEM_NRSOLICMP,
                                              @V_ITEM_CDFILLAN,
                                              @V_ITEM_CDPRODUTO,
                                              @V_ITEM_DTPROGENTR;
                  WHILE (@@FETCH_STATUS = 0) BEGIN
                     /* Log de Alterao */
                     INSERT INTO MOVOPSOL
                       (CDFILSOLMOV,
                        CDFILLANMOV,
                        NRSOLIMOV,
                        CDPRODUTO,
                        DTENTROPER,
                        DTOPERSOL,
                        CDOPERADOR,
                        QTANTOPER,
                        QTDEPOPER,
                        DSJUSTOPER)
                     SELECT
                        @P_CDFILSOLI,
                        CDFILLAN,
                        NRSOLICMP,
                        CDPRODUTO,
                        DTPROGENTR,
                        GETDATE(),
                        @P_CDOPERADOR,
                        QTSOLIPROD,
                        0,
                        'Empenho de OL - Consol. Sem Item'
                     FROM ITEMSOLI
                     WHERE CDFILSOLI = @P_CDFILSOLI
                       AND CDFILLAN = @V_ITEM_CDFILLAN
                       AND CDPRODUTO = @V_ITEM_CDPRODUTO
                       AND NRSOLICMP = @V_ITEM_NRSOLICMP
                       AND DTPROGENTR = @V_ITEM_DTPROGENTR;

                     SELECT  @V_ITEMSOLI_AUX_QTSOLIPROD = MAX(QTSOLIPROD)
                       FROM ITEMSOLI
                      WHERE CDFILSOLI  = @P_CDFILSOLI
                        AND CDFILLAN   = @V_ITEM_CDFILLAN
                        AND CDPRODUTO  = @V_ITEM_CDPRODUTO
                        AND NRSOLICMP  = @V_ITEM_NRSOLICMP
                        AND DTPROGENTR = @V_ITEM_DTPROGENTR;

                     INSERT INTO ITEMSOLIDEL
                       (CDFILSOLI,
                       CDFILLAN,
                       NRSOLICMP,
                       CDPRODUTO,
                       DTPROGENTR,
                       QTSOLIORIGDEL)
                     SELECT
                       @P_CDFILSOLI,
                       @V_ITEM_CDFILLAN,
                       @V_ITEM_NRSOLICMP,
                       @V_ITEM_CDPRODUTO,
                       @V_ITEM_DTPROGENTR,
                       @V_ITEMSOLI_AUX_QTSOLIPROD
                     WHERE
                     NOT EXISTS
                        (SELECT (1)
                        FROM ITEMSOLIDEL
                        WHERE CDFILSOLI     = @P_CDFILSOLI
                          AND CDFILLAN      = @V_ITEM_CDFILLAN
                          AND NRSOLICMP     = @V_ITEM_CDPRODUTO
                          AND CDPRODUTO     = @V_ITEM_NRSOLICMP
                          AND DTPROGENTR    = @V_ITEM_DTPROGENTR);

                     DELETE FROM ITEMSOLI
                     WHERE CDFILSOLI = @P_CDFILSOLI
                       AND CDFILLAN = @V_ITEM_CDFILLAN
                       AND CDPRODUTO = @V_ITEM_CDPRODUTO
                       AND NRSOLICMP = @V_ITEM_NRSOLICMP
                       AND DTPROGENTR = @V_ITEM_DTPROGENTR;

                     FETCH NEXT FROM C_ITEM INTO @V_ITEM_NRSOLICMP,
                                                 @V_ITEM_CDFILLAN,
                                                 @V_ITEM_CDPRODUTO,
                                                 @V_ITEM_DTPROGENTR;
                  END;
                  CLOSE C_ITEM;
                  DEALLOCATE C_ITEM;
               END;
            END;
            SET @V_VRFATCONVOL = @V_ITEMCONSSOLOL_VRFATOCONV;
            FETCH NEXT FROM C_ITEMSOLI INTO @V_ITEMSOLI_QTDE,
                                            @V_ITEMSOLI_CDPRODESTO,
                                            @V_ITEMSOLI_CDFILLANCONS,
                                            @V_ITEMSOLI_DTENTRCONSOL,
                                            @V_ITEMSOLI_DTPROGENTR;
         END;
         CLOSE C_ITEMSOLI;
         DEALLOCATE C_ITEMSOLI;
         SELECT
            @V_QTDESOLDEPOIS = SUM(IT.QTSOLIPROD*ISNULL(PR.VRFATOCONV, 1))
         FROM
            ITEMSOLI IT, PRODUTO PR
         WHERE IT.CDFILSOLI             = @P_CDFILSOLI
           AND PR.CDPRODESTO            = @P_CDPRODESTO
           AND PR.CDPRODUTO             = IT.CDPRODUTO
           AND IT.CDFILSOLI            <> @P_CDFILIOPELOG
           AND ISNULL(IT.IDSOLIAPROV, @W_S) = @W_S
           AND ISNULL(IT.IDITMCONS, @W_N)   = @W_N
           AND IT.CDFILIOPELOG          = @P_CDFILIOPELOG
           AND IT.NRSEQUCONSOL          = @P_NRSEQCONSOL;

         SET @V_QTDERESTSOL = @V_QTDESOLDEPOIS - @V_QTDETOTALSOL;
         IF @V_QTDERESTSOL > 0 BEGIN
            DECLARE C_ITEMSOLI_FINAL CURSOR FOR
               SELECT
                  IT.CDFILSOLI,
                  IT.CDFILLAN,
                  IT.NRSOLICMP,
                  IT.CDPRODUTO,
                  IT.DTPROGENTR,
                  (IT.QTSOLIPROD*ISNULL(PR.VRFATOCONV, 1)) QTSOLIPROD,
                  ISNULL(PR.VRARREDCMP, 0) VRARREDCMP,
                  ISNULL(PR.VRFATOCONV, 1) VRFATOCONV
               FROM
                  ITEMSOLI IT, PRODUTO PR
               WHERE IT.CDFILSOLI             = @P_CDFILSOLI
                 AND PR.CDPRODESTO            = @P_CDPRODESTO
                 AND PR.CDPRODUTO             = IT.CDPRODUTO
                 AND IT.CDFILSOLI            <> @P_CDFILIOPELOG
                 AND ISNULL(IT.IDSOLIAPROV, @W_S) = @W_S
                 AND ISNULL(IT.IDITMCONS, @W_N)   = @W_N
                 AND IT.CDFILIOPELOG          = @P_CDFILIOPELOG
                 AND IT.NRSEQUCONSOL          = @P_NRSEQCONSOL
               ORDER BY
                  DTPROGENTR DESC,
                  (IT.QTSOLIPROD*ISNULL(PR.VRFATOCONV, 1)) DESC

            OPEN C_ITEMSOLI_FINAL;
            FETCH NEXT FROM C_ITEMSOLI_FINAL INTO @V_ITEMSOLI_FINAL_CDFILSOLI,
                                                  @V_ITEMSOLI_FINAL_CDFILLAN,
                                                  @V_ITEMSOLI_FINAL_NRSOLICMP,
                                                  @V_ITEMSOLI_FINAL_CDPRODUTO,
                                                  @V_ITEMSOLI_FINAL_DTPROGENTR,
                                                  @V_ITEMSOLI_FINAL_QTSOLIPROD,
                                                  @V_ITEMSOLI_FINAL_VRARREDCMP,
                                                  @V_ITEMSOLI_FINAL_VRFATOCONV;
            WHILE (@@FETCH_STATUS = 0) BEGIN
            --ALTERAES AQUI
               /*
                  SE NO POSSUIR VALOR PARA A FILIAL SOLICITANTE, RETORNA O VALOR DA FILIAL OL,
                  CASO CONTRRIO RETORNA ZERO E A PROCEDURE NO CONSIDERA O PARMETRO
               */
               SELECT @V_REJEICAOOL = MAX(ISNULL(PF.VRMINEMPENHOOL, ISNULL(PFOL.VRMINEMPENHOOL, 0)))
               FROM PRODFILI PF, ITEMSOLI IT, PRODFILI PFOL
               WHERE PF.CDFILIAL   = @P_CDFILSOLI
                 AND PF.CDPRODUTO  = IT.CDPRODUTO
                 AND PF.CDPRODUTO  = PFOL.CDPRODUTO
                 AND PFOL.CDFILIAL = IT.CDFILIOPELOG
                 AND IT.CDFILSOLI  = @V_ITEMSOLI_FINAL_CDFILSOLI
                 AND IT.CDFILLAN   = @V_ITEMSOLI_FINAL_CDFILLAN
                 AND IT.NRSOLICMP  = @V_ITEMSOLI_FINAL_NRSOLICMP
                 AND IT.CDPRODUTO  = @V_ITEMSOLI_FINAL_CDPRODUTO
                 AND IT.DTPROGENTR = @V_ITEMSOLI_FINAL_DTPROGENTR;
                 
               SET @V_QTDFINAL = CAST((@V_QTDETOTALSOL) AS NUMERIC)%@V_VRFATCONVOL; --RESTO DA DIVISO
               
               IF (@V_QTDFINAL < (@V_VRFATCONVOL*@V_REJEICAOOL) AND (@V_QTDERESTSOL > 0)) BEGIN
                  DECLARE C_ITEMCONS CURSOR FOR(
                     SELECT 
                        I.CDFILSOLI,
                        I.CDFILLAN,
                        I.NRSEQUCONSOL,
                        I.CDPRODUTO,
                        I.DTENTRCONSOL
                     FROM ITEMCONSSOLOL I, PRODUTO P, RELACONSOLOLNC R,
                     (
                           SELECT IT.DTPROGENTR, IT.NRSEQUCONSOL
                           FROM ITEMSOLI IT
                           WHERE IT.CDFILSOLI  = @V_ITEMSOLI_FINAL_CDFILSOLI
                             AND IT.CDFILLAN   = @V_ITEMSOLI_FINAL_CDFILLAN
                             AND IT.NRSOLICMP  = @V_ITEMSOLI_FINAL_NRSOLICMP
                             AND IT.CDPRODUTO  = @V_ITEMSOLI_FINAL_CDPRODUTO
                             AND IT.DTPROGENTR = @V_ITEMSOLI_FINAL_DTPROGENTR
                     ) ITS
                     WHERE I.NRSEQUCONSOL = @P_NRSEQCONSOL
                       AND I.CDFILSOLI    = @P_CDFILIOPELOG
                       AND P.CDPRODESTO   = @P_CDPRODESTO
                       AND P.CDPRODUTO    = I.CDPRODUTO
                       AND I.NRSEQUCONSOL = R.NRSEQUCONSOL
                       AND R.NRSEQUCONSOL = ITS.NRSEQUCONSOL
                       AND I.CDFILLAN     = R.CDFILLANCONS
                       AND I.DTENTRCONSOL = R.DTENTRCONSOL
                       AND I.CDPRODUTO    = R.CDPRODUTOCONS
                       AND R.CDFILSOLCONS = @P_CDFILSOLI
                       AND R.DTENTRCONSOL = ITS.DTPROGENTR
                  )
                  OPEN C_ITEMCONS;
                  FETCH NEXT FROM C_ITEMCONS INTO
                     @C_ITEMCONS_CDPRODUTO,
                     @C_ITEMCONS_NRSEQUCONSOL,
                     @C_ITEMCONS_CDFILSOLI,
                     @C_ITEMCONS_CDFILLAN,
                     @C_ITEMCONS_DTENTRCONSOL;
                  WHILE (@@FETCH_STATUS = 0) BEGIN
                     UPDATE ITEMCONSSOLOL
                     SET QTENTRCONSOL = QTENTRCONSOL - 1
                     WHERE I.CDFILSOLI    = @C_ITEMCONS_CDPRODUTO
                       AND I.CDFILLAN     = @C_ITEMCONS_NRSEQUCONSOL
                       AND I.NRSEQUCONSOL = @C_ITEMCONS_CDFILSOLI
                       AND I.CDPRODUTO    = @C_ITEMCONS_CDFILLAN
                       AND I.DTENTRCONSOL = @C_ITEMCONS_DTENTRCONSOL
                       AND QTENTRCONSOL > 1;
                     IF @@ROWCOUNT = 0 BEGIN
                        DELETE FROM ITEMCONSSOLOL
                        WHERE I.CDFILSOLI    = @C_ITEMCONS_CDPRODUTO
                          AND I.CDFILLAN     = @C_ITEMCONS_NRSEQUCONSOL
                          AND I.NRSEQUCONSOL = @C_ITEMCONS_CDFILSOLI
                          AND I.CDPRODUTO    = @C_ITEMCONS_CDFILLAN
                          AND I.DTENTRCONSOL = @C_ITEMCONS_DTENTRCONSOL;
                     END;
                  END;
                  
                  UPDATE ITEMSOLI
                     SET QTSOLIPROD = (QTSOLIPROD - V_QTDERESTSOL) - V_QTDFINAL
                   WHERE CDFILSOLI = @V_ITEMSOLI_FINAL_CDFILSOLI
                     AND CDFILLAN  = @V_ITEMSOLI_FINAL_CDFILLAN
                     AND NRSOLICMP = @V_ITEMSOLI_FINAL_NRSOLICMP
                     AND CDPRODUTO = @V_ITEMSOLI_FINAL_CDPRODUTO
                     AND DTPROGENTR = @V_ITEMSOLI_FINAL_DTPROGENTR
                     AND FLOOR((QTSOLIPROD - V_QTDERESTSOL)/V_VRFATCONVOL) >= 1
                  IF @@ROWCOUNT = 0 BEGIN
                     DELETE FROM ITEMSOLI
                     WHERE CDFILSOLI = @V_ITEMSOLI_FINAL_CDFILSOLI
                       AND CDFILLAN  = @V_ITEMSOLI_FINAL_CDFILLAN
                       AND NRSOLICMP = @V_ITEMSOLI_FINAL_NRSOLICMP
                       AND CDPRODUTO = @V_ITEMSOLI_FINAL_CDPRODUTO
                       AND DTPROGENTR = @V_ITEMSOLI_FINAL_DTPROGENTR;
                     V_QTDERESTSOL := 0;
                  ELSE
                     V_QTDERESTSOL := V_QTDERESTSOL - 1;
                  END;
                  
               END;

               IF @V_QTDERESTSOL > 0 BEGIN
                  IF @V_ITEMSOLI_FINAL_QTSOLIPROD > @V_QTDERESTSOL BEGIN
                     SET @V_QTDEAUX = @V_QTDERESTSOL/@V_ITEMSOLI_FINAL_VRFATOCONV;
                     IF @V_ITEMSOLI_FINAL_VRARREDCMP > 0 BEGIN
                        SET @V_QTDEAUX = FLOOR(@V_QTDEAUX / @V_ITEMSOLI_FINAL_VRARREDCMP) * @V_ITEMSOLI_FINAL_VRARREDCMP;
                     END;
                     IF @V_QTDEAUX > 0 BEGIN
                        /* Log de Alterao */
                        INSERT INTO MOVOPSOL
                          (CDFILSOLMOV,
                           CDFILLANMOV,
                           NRSOLIMOV,
                           CDPRODUTO,
                           DTENTROPER,
                           DTOPERSOL,
                           CDOPERADOR,
                           QTANTOPER,
                           QTDEPOPER,
                           DSJUSTOPER)
                        SELECT
                           ITEMSOLI.CDFILSOLI,
                           ITEMSOLI.CDFILLAN,
                           ITEMSOLI.NRSOLICMP,
                           ITEMSOLI.CDPRODUTO,
                           ITEMSOLI.DTPROGENTR,
                           GETDATE(),
                           @P_CDOPERADOR,
                           ITEMSOLI.QTSOLIPROD,
                           ITEMSOLI.QTSOLIPROD - @V_QTDEAUX,
                           'Empenho de OL - Subtrai'
                        FROM
                           ITEMSOLI
                        WHERE CDFILSOLI = @V_ITEMSOLI_FINAL_CDFILSOLI
                          AND CDFILLAN = @V_ITEMSOLI_FINAL_CDFILLAN
                          AND NRSOLICMP = @V_ITEMSOLI_FINAL_NRSOLICMP
                          AND CDPRODUTO = @V_ITEMSOLI_FINAL_CDPRODUTO
                          AND DTPROGENTR = @V_ITEMSOLI_FINAL_DTPROGENTR;

                        UPDATE ITEMSOLI
                        SET QTSOLIORIG = ISNULL(QTSOLIORIG, QTSOLIPROD),
                            QTSOLIPROD = QTSOLIPROD - @V_QTDEAUX
                        WHERE CDFILSOLI = @V_ITEMSOLI_FINAL_CDFILSOLI
                          AND CDFILLAN = @V_ITEMSOLI_FINAL_CDFILLAN
                          AND NRSOLICMP = @V_ITEMSOLI_FINAL_NRSOLICMP
                          AND CDPRODUTO = @V_ITEMSOLI_FINAL_CDPRODUTO
                          AND DTPROGENTR = @V_ITEMSOLI_FINAL_DTPROGENTR;

                        SET @V_QTDERESTSOL = 0;
                     END;
                  END
                  ELSE BEGIN
                     SELECT @V_COUNT = COUNT(1)
                     FROM ITEMSOLI, PRODUTO P
                     WHERE CDFILSOLI = @V_ITEMSOLI_FINAL_CDFILSOLI
                       AND CDFILLAN = @V_ITEMSOLI_FINAL_CDFILLAN
                       AND NRSOLICMP = @V_ITEMSOLI_FINAL_NRSOLICMP
                       AND P.CDPRODESTO = @P_CDPRODESTO
                       AND P.CDPRODUTO = ITEMSOLI.CDPRODUTO;


                     IF ISNULL(@V_COUNT, 0) > 1 BEGIN
                        /* Log de Alterao */
                        INSERT INTO MOVOPSOL
                          (CDFILSOLMOV,
                           CDFILLANMOV,
                           NRSOLIMOV,
                           CDPRODUTO,
                           DTENTROPER,
                           DTOPERSOL,
                           CDOPERADOR,
                           QTANTOPER,
                           QTDEPOPER,
                           DSJUSTOPER)
                        VALUES
                          (@V_ITEMSOLI_FINAL_CDFILSOLI,
                           @V_ITEMSOLI_FINAL_CDFILLAN,
                           @V_ITEMSOLI_FINAL_NRSOLICMP,
                           @V_ITEMSOLI_FINAL_CDPRODUTO,
                           @V_ITEMSOLI_FINAL_DTPROGENTR,
                           GETDATE(),
                           @P_CDOPERADOR,
                           @V_ITEMSOLI_FINAL_QTSOLIPROD,
                           0,
                           'Empenho de OL - Exclui');

                        DELETE FROM ITEMSOLI
                        WHERE CDFILSOLI = @V_ITEMSOLI_FINAL_CDFILSOLI
                          AND CDFILLAN = @V_ITEMSOLI_FINAL_CDFILLAN
                          AND NRSOLICMP = @V_ITEMSOLI_FINAL_NRSOLICMP
                          AND CDPRODUTO = @V_ITEMSOLI_FINAL_CDPRODUTO
                          AND DTPROGENTR = @V_ITEMSOLI_FINAL_DTPROGENTR;
                        SET @V_QTDERESTSOL = @V_QTDERESTSOL - @V_ITEMSOLI_FINAL_QTSOLIPROD;
                     END;
                  END;
               END;
               FETCH NEXT FROM C_ITEMSOLI_FINAL INTO @V_ITEMSOLI_FINAL_CDFILSOLI,
                                                     @V_ITEMSOLI_FINAL_CDFILLAN,
                                                     @V_ITEMSOLI_FINAL_NRSOLICMP,
                                                     @V_ITEMSOLI_FINAL_CDPRODUTO,
                                                     @V_ITEMSOLI_FINAL_DTPROGENTR,
                                                     @V_ITEMSOLI_FINAL_QTSOLIPROD,
                                                     @V_ITEMSOLI_FINAL_VRARREDCMP,
                                                     @V_ITEMSOLI_FINAL_VRFATOCONV;
            END;
            CLOSE C_ITEMSOLI_FINAL;
            DEALLOCATE C_ITEMSOLI_FINAL;
         END
         ELSE BEGIN
            IF @V_QTDERESTSOL < 0 BEGIN
               DECLARE C_ITEMSOLI_FINAL CURSOR FOR
                  SELECT
                     IT.CDFILSOLI,
                     IT.CDFILLAN,
                     IT.NRSOLICMP,
                     IT.CDPRODUTO,
                     IT.DTPROGENTR,
                     (IT.QTSOLIPROD*ISNULL(PR.VRFATOCONV, 1)) QTSOLIPROD,
                     ISNULL(PR.VRARREDCMP, 0) VRARREDCMP,
                     ISNULL(PR.VRFATOCONV, 1) VRFATOCONV
                  FROM
                     ITEMSOLI IT, PRODUTO PR
                  WHERE IT.CDFILSOLI             = @P_CDFILSOLI
                    AND PR.CDPRODESTO            = @P_CDPRODESTO
                    AND PR.CDPRODUTO             = IT.CDPRODUTO
                    AND IT.CDFILSOLI            <> @P_CDFILIOPELOG
                    AND ISNULL(IT.IDSOLIAPROV, @W_S) = @W_S
                    AND ISNULL(IT.IDITMCONS, @W_N)   = @W_N
                    AND IT.CDFILIOPELOG          = @P_CDFILIOPELOG
                    AND IT.NRSEQUCONSOL          = @P_NRSEQCONSOL
                  ORDER BY
                     DTPROGENTR,
                     (IT.QTSOLIPROD*ISNULL(PR.VRFATOCONV, 1))

               OPEN C_ITEMSOLI_FINAL;
               FETCH NEXT FROM C_ITEMSOLI_FINAL INTO @V_ITEMSOLI_FINAL_CDFILSOLI,
                                                     @V_ITEMSOLI_FINAL_CDFILLAN,
                                                     @V_ITEMSOLI_FINAL_NRSOLICMP,
                                                     @V_ITEMSOLI_FINAL_CDPRODUTO,
                                                     @V_ITEMSOLI_FINAL_DTPROGENTR,
                                                     @V_ITEMSOLI_FINAL_QTSOLIPROD,
                                                     @V_ITEMSOLI_FINAL_VRARREDCMP,
                                                     @V_ITEMSOLI_FINAL_VRFATOCONV;
               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SET @V_QTDEAUX = ABS(@V_QTDERESTSOL/@V_ITEMSOLI_FINAL_VRFATOCONV);
                  IF @V_ITEMSOLI_FINAL_VRARREDCMP > 0 BEGIN
                     SET @V_QTDEAUX = CEILING(CAST(@V_QTDEAUX AS DOUBLE PRECISION) / @V_ITEMSOLI_FINAL_VRARREDCMP) * @V_ITEMSOLI_FINAL_VRARREDCMP;
                  END;

                  INSERT INTO MOVOPSOL
                    (CDFILSOLMOV,
                     CDFILLANMOV,
                     NRSOLIMOV,
                     CDPRODUTO,
                     DTENTROPER,
                     DTOPERSOL,
                     CDOPERADOR,
                     QTANTOPER,
                     QTDEPOPER,
                     DSJUSTOPER)
                  SELECT
                     ITEMSOLI.CDFILSOLI,
                     ITEMSOLI.CDFILLAN,
                     ITEMSOLI.NRSOLICMP,
                     ITEMSOLI.CDPRODUTO,
                     ITEMSOLI.DTPROGENTR,
                     GETDATE(),
                     @P_CDOPERADOR,
                     ITEMSOLI.QTSOLIPROD,
                     ITEMSOLI.QTSOLIPROD + @V_QTDEAUX,
                     'Empenho de OL - Acresce'
                  FROM
                     ITEMSOLI
                  WHERE ITEMSOLI.CDFILSOLI = @V_ITEMSOLI_FINAL_CDFILSOLI
                    AND ITEMSOLI.CDFILLAN = @V_ITEMSOLI_FINAL_CDFILLAN
                    AND ITEMSOLI.NRSOLICMP = @V_ITEMSOLI_FINAL_NRSOLICMP
                    AND ITEMSOLI.CDPRODUTO = @V_ITEMSOLI_FINAL_CDPRODUTO
                    AND ITEMSOLI.DTPROGENTR = @V_ITEMSOLI_FINAL_DTPROGENTR;

                  UPDATE ITEMSOLI
                  SET QTSOLIORIG = ISNULL(QTSOLIORIG, QTSOLIPROD),
                      QTSOLIPROD = QTSOLIPROD + @V_QTDEAUX
                  WHERE ITEMSOLI.CDFILSOLI = @V_ITEMSOLI_FINAL_CDFILSOLI
                    AND ITEMSOLI.CDFILLAN = @V_ITEMSOLI_FINAL_CDFILLAN
                    AND ITEMSOLI.NRSOLICMP = @V_ITEMSOLI_FINAL_NRSOLICMP
                    AND ITEMSOLI.CDPRODUTO = @V_ITEMSOLI_FINAL_CDPRODUTO
                    AND ITEMSOLI.DTPROGENTR = @V_ITEMSOLI_FINAL_DTPROGENTR;
                  BREAK;
               END;
               CLOSE C_ITEMSOLI_FINAL;
               DEALLOCATE C_ITEMSOLI_FINAL;
            END;
         END;
      END;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'EMPENHO_OL','5.05.064';
GO
