function SqlLogsController(ScreenService, ACLUtilities, templateManager, ZhFilterPreferences, SqlLogsService) {
    /* --------------------------
     *------ Get Widgets ------
     *---------------------------
     */
    var getSqlLogsWidget = function() {
        return templateManager.container.getWidget('SQL_LOGS_WIDGET');
    };

    this.sqlLogsEventWidgetOnEnter = function () {
        var widget = getSqlLogsWidget();
        if(ACLUtilities.isAppliedFilter(widget)) {
            widget.reload();
        } else {
            SqlLogsService.findDbUser().then(function (response) {
                widget.currentRow.PARSING_SCHEMA_NAME = response.dataset.data[0].DBUSER;
                ZhFilterPreferences.setOriginalFilter(widget.id, widget.currentRow);
                ACLUtilities.applyDefaultFilterOnEnter(widget);
            });
        }
    };
    
    this.sqlLogsEventFilterAfterApply = function() {
        var widget = getSqlLogsWidget();
        ACLUtilities.setFilterInit(widget);
    };

    this.sqlLogsActionEventBack = function() {
        ScreenService.closeSwipe();
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('SqlLogsController', SqlLogsController);
});
